using System.IO;
using System.Collections;

namespace PLDAbout
{
	public class DevList
	{
		public class Element
		{
			private string dev;
			private int offset;

			public Element(string dev, int offset)
			{
				this.dev = dev;
				this.offset = offset;
			}

			public string Developer
			{
				get
				{
					return dev;
				}
			}

			public int Offset
			{
				get
				{
					return offset;
				}
			}
		}

		private ArrayList l = new ArrayList();
		private int height=0;

		public DevList(string fn, int start, int offset)
		{
			ArrayList names = LoadFromAssembly(fn);
			IEnumerator e = names.GetEnumerator();

			while(e.MoveNext())
			{
				l.Add(new Element((string)e.Current, start + height));
				height += offset;
			}
		}

		private ArrayList LoadFromFile(string fn)
		{
			ArrayList names = new ArrayList();
			StreamReader s = new StreamReader(fn);
			string str;

			while((str = s.ReadLine()) != null)
				names.Add(str);

			s.Close();

			return names;
		}

		private ArrayList LoadFromAssembly(string fn)
		{
			ArrayList names = new ArrayList();
			StreamReader s = new StreamReader(System.Reflection.Assembly.GetCallingAssembly().GetManifestResourceStream(fn));
			string str;

			while((str = s.ReadLine()) != null)
				names.Add(str);

			s.Close();

			return names;
		}

		public ArrayList List
		{
			get
			{
				return l;
			}
		}

		public int Height
		{
			get
			{
				return height;
			}
		}
	}
}
