using System;
using System.Reflection;
using System.Runtime.InteropServices;

namespace Gdk
{
	public class Graphics
	{
		private Graphics() {}

		[DllImport("libgdk-x11-2.0.so.0")]
		internal static extern IntPtr gdk_cairo_create(IntPtr handle);

		public static Cairo.Graphics CreateDrawable(Gdk.Drawable drawable)
		{
			return new Cairo.Graphics(gdk_cairo_create(drawable.Handle));
		}
	}
}

namespace Cairo
{
	internal class CairoAPI
	{
		internal const string CairoImp = "libcairo-2.dll";
		
		[DllImport (CairoImp)]
		public static extern void cairo_text_extents(IntPtr cr, string utf8, ref TextExtents extents);
	}

	public class Graphicx
	{
		Graphicx()
		{
		}

		static public TextExtents TextExtents(IntPtr state, string str)
		{
			TextExtents t_extents = new TextExtents();
			CairoAPI.cairo_text_extents(state, str, ref t_extents);
			return t_extents;
		}
	}
}
